unit U_impgr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    Button3: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
  uses Printers;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var l_style: tBrushStyle;
begin
  Canvas.TextOut(10, 50, 'Bonjour d''un dessin graphique');
  Canvas.Ellipse(10, 60, 200, 200);
{
  Canvas.Ellipse(10, 100, 200, 200);
  Canvas.StretchDraw(Rect(10, 200, 150, 350), Image1.Picture.Graphic);
}
  Canvas.Draw(10, 160, Image1.Picture.Graphic);

  Canvas.StretchDraw(Rect(170, 50, 500, 200), Image1.Picture.Graphic);
{
  l_style:= Canvas.Brush.Style;
  Canvas.Brush.Style:= bsClear;
  Canvas.Rectangle(170, 50, 350, 200);
  Canvas.Brush.Style:= l_style;
}
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Printer.BeginDoc;

  Printer.Canvas.TextOut(10, 50, 'Bonjour d''un dessin graphique');
  Printer.Canvas.Ellipse(10, 60, 200, 200);
{
  Printer.Canvas.StretchDraw(Rect(10, 50, 150, 350), Image1.Picture.Graphic);
}
  Printer.Canvas.Draw(10, 160, Image1.Picture.Graphic);


{
  Printer.Canvas.StretchDraw(Rect(170, 50, 150, 450), Image1.Picture.Graphic);
}
  Printer.Canvas.StretchDraw(Rect(170, 50, 500, 200), Image1.Picture.Graphic);

  Printer.EndDoc;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  exit;
  Canvas.textOut(0, 0, IntToStr(X)+ ' '+ IntToStr(Y)+ '<   ');
end;

end.
