unit U_prsetu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    PrinterSetupDialog1: TPrinterSetupDialog;
    Button1: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
uses Printers;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var imprimante: tPrinter;
    resultat: String;
begin
{
  PrinterSetupDialog1.Execute;
}
  imprimante := TPrinter.Create;
  ListBox1.Items := imprimante.Printers;
  ListBox2.Items := imprimante.Fonts;

  Canvas.TextOut(10, ListBox1.Top+ ListBox1.Height+ 10,
      imprimante.Printers[imprimante.PrinterIndex]);
  imprimante.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var resultat: String;
    x, y: Integer;
begin
  PrinterSetupDialog1.Execute;


{
  if PrintDialog1.Execute
    then ;

  With Printer do
    Canvas.TextOut(x, y+ 20, Printers[PrinterIndex]);
  !!! provoque une exception printer pas ouvert
}
  x:= Button2.Left; y:= Button2.Top+ Button2.Height+ 10;
  If Printer.Printing
    then Canvas.TextOut(x, y, 'imprime')
    else Canvas.TextOut(x, y, 'imprime PAS');

  Canvas.TextOut(x, y+ 20, Printer.Printers[Printer.PrinterIndex]);

  if Printer.Orientation= poPortrait
    then resultat:= 'Portrait '
    else resultat:= 'Paysage ';

  Canvas.TextOut(x, y+ 40, resultat+ 'H= '+ IntToStr(Printer.PageHeight)+ ', L= '+ IntToStr(Printer.PageWidth)+ '  ');

{
  if PrinterSetupDialog1.ChangeDefault
    then resultat:= 'PrinterSetupDialog.ChangeDefault'
    else resultat:= 'NOT PrinterSetupDialog.ChangeDefault';
}
  Canvas.TextOut(x, y+ 60, resultat);
end;

end.
unit U_imprim;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    PrintDialog1: TPrintDialog;
    Button1: TButton;
    ListBox1: TListBox;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
  Uses Printers;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var imprimante: tPrinter;
    resultat: String;
begin

  PrinterSetupDialog1.Execute;

  imprimante := TPrinter.Create;
  ListBox1.Items := imprimante.Printers;
  Canvas.TextOut(200, 10, imprimante.Printers[imprimante.PrinterIndex]);
  imprimante.Free;

{
  if PrintDialog1.Execute
    then
}
{
  with Printer do
  !!! provoque une exception printer pas ouvert
}
  begin
    If Printer.Printing
      then Canvas.TextOut(200, 30, 'imprime')
      else Canvas.TextOut(200, 30, 'imprime PAS');

    Canvas.TextOut(200, 50, Printer.Printers[Printer.PrinterIndex]);
    if Printer.Orientation= poPortrait
      then resultat:= 'Portrait '
      else resultat:= 'Paysage ';
    resultat:= resultat+ 'H= '+ IntToStr(Printer.PageHeight)+ ', L= '+ IntToStr(Printer.PageWidth);

    Canvas.TextOut(200, 70, '>'+ resultat+ '<');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
{
  Print;
}
end;

end.
