unit U_clipfo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Image1: TImage;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
  uses clipbrd;
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit1.SelectAll;
  Edit1.CopyToClipboard;
{
  Clipboard.AsPicture:= Image1.Picture;
}
  Clipboard.Assign(Image1.Picture);
end;

procedure TForm1.Button2Click(Sender: TObject);
var indice: Integer;
    le_format: Word;
    le_resultat,  le_nom: String;
begin
  For indice:= 0 to Clipboard.FormatCount- 1 do
  begin
    le_format:= Clipboard.Formats[indice];

    le_resultat:= IntToStr(le_format);
    le_nom:= '?';
    Case le_format of
      cf_Text : le_nom:= 'cf_Text';
      cf_Bitmap : le_nom:= 'cf_Bitmap';
      cf_Palette : le_nom:= 'cf_Palette';
      cf_OEMText : le_nom:= 'cf_OEMText';

      cf_OwnerDisplay : le_nom:= 'cf_OwnerDisplay';
      cf_Wave : le_nom:= 'cf_Wave';
      cf_DIB : le_nom:= 'cf_DIB';
      cf_TIFF : le_nom:= 'cf_TIFF';
      else
        le_nom[0]:= chr(GetClipboardFormatName(le_format, @le_nom[1], 255));
    end;

    (* -- cf_Picture est un VARIABLE *)
    if le_format= cf_Picture
      then le_nom:= le_nom+ ' (picture) ';

    Canvas.TextOut(200, 50+ indice* 20,
      le_resultat+ ' '+ le_nom+ '<  ');
  end;
end;

end.

