unit U_clavi3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Button1: TButton;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure mon_appli_on_message(var Msg: tMsg; var Handled: Boolean);
    procedure Fichier1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-declarations }
    procedure Affiche(le_texte: String);
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tForm1.Affiche(le_texte: String);
  var y: Integer;
      y_bouton: Integer;
  begin
    y:= (ClientRect.Bottom div 20- 2)* 20;
    y_bouton:= Button1.Top;
    ScrollBy(0, -20); Update;
    Button1.Top:= y_bouton;

    if le_texte[1]= 'B'
      then le_texte:= '                                        '
          + le_texte;

    Canvas.TextOut(10, y, le_texte);

{
    if KeyPreview
      then Canvas.TextOut(300, y, 'Preview')
      else Canvas.TextOut(300, y, 'PAS Preview')
}
  end; (* affiche *)

function f_nom_touche(touche_virtuelle: Word): String;
  var le_texte: String;
  begin
    case touche_virtuelle of
      vk_Shift : le_texte:= 'Shift';
      vk_Menu : le_texte:= 'Alt';
      vk_Up : le_texte:= 'Up';
      vk_F1 : le_texte:= 'F1';
      ord('A')..ord('Z') : le_texte:= chr(touche_virtuelle);
      else le_texte:= '??';
    end;

    f_nom_touche:= le_texte;
  end; (* f_nom_touche *)

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche('  KeyDown '+ f_nom_touche(Key));
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  affiche('    KeyPress '+ Key);
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche('  KeyUp '+ f_nom_touche(Key));
end;

procedure tForm1.mon_appli_on_message(var Msg: tMsg; var Handled: Boolean);
  begin
    case Msg.Message of
      wm_KeyDown : affiche('msg wm_KeyDown '+ f_nom_touche(Msg.wParam));
      wm_SysKeyDown : affiche('msg wm_SysKeyDown');
      wm_Char : affiche('msg wm_Char '+ chr(Msg.wParam));
      wm_KeyUp : affiche('msg wm_KeyUp '+ f_nom_touche(Msg.wParam));
    end;
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnMessage:= mon_appli_on_message;
{
  SetFocus
}
  ActiveControl:= Self;
end;

procedure TForm1.Fichier1Click(Sender: TObject);
begin
  affiche('      dans clic &Fichier');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  KeyPreview:= Not KeyPreview;
end;

procedure TForm1.Button1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche('B  KeyDown '+ f_nom_touche(Key));
end;

procedure TForm1.Button1KeyPress(Sender: TObject; var Key: Char);
begin
  affiche('B   KeyPress '+ Key);
end;

procedure TForm1.Button1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche('B  KeyUp '+ f_nom_touche(Key));
end;

end.
