unit U_appl1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure mon_appli_on_activate(Sender: TObject);
    procedure mon_appli_on_idle(Sender: TObject; Var Done: Boolean);
    procedure mon_appli_on_message(var Msg: TMsg; var Handled: Boolean);
    procedure FormClick(Sender: TObject);
  private
    numero, numero_idle: Integer;
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
  uses u_appl2;

{$R *.DFM}

function f_numero: String;
  begin
    Form2.ScrollBy(0, -20); Form2.Update;
    f_numero:= IntToStr(Form1.numero);
    inc(Form1.numero);
  end; (* f_numero *)

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnActivate := mon_appli_on_activate;
  Application.OnIdle := mon_appli_on_idle;
  Application.OnMessage := mon_appli_on_message;
end;

procedure TForm1.mon_appli_on_activate(Sender: TObject);
begin
  Form2.Canvas.TextOut(0, Form2.ligne_du_bas, f_numero+ ' --- Appli Activate');
end;

procedure TForm1.mon_appli_on_idle(Sender: TObject; Var Done: Boolean);
begin
  Done:= True;
  Form1.Canvas.TextOut(250, 10, ' OnIdle '+ IntToStr(numero_idle)+ '     ');
  inc(numero_idle);
end;

procedure tForm1.mon_appli_on_message(var Msg: TMsg; var Handled: Boolean);
var resultat: String;
begin
  if (Msg.Message<> wm_MouseMove) and (Msg.Message<> wm_NCMouseMove)
    then begin
        Case msg.Message of
          wm_lButtonDown : resultat:= ' wm_lButtonDown';
          wm_lButtonUp : resultat:= ' wm_lButtonUp';
          else resultat:= '';
        end;

        resultat:= f_numero+ ' Message '+ IntToStr(Msg.Message) + resultat;
        Form2.Canvas.TextOut(0, Form2.ligne_du_bas, resultat);
      end;
end;

procedure TForm1.FormClick(Sender: TObject);
var indice: Integer;
begin
  For indice:= 0 to Application.ComponentCount- 1 do
    Canvas.TextOut(130, 10+ indice* 20,
      (Application.Components[indice] as tForm).Caption+ '<');
end;

end.

