unit U_filgr6;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Menus;

type
  Tfille_graphique = class(TForm)
    PaintBox1: TPaintBox;
    MainMenu1: TMainMenu;
    Type1: TMenuItem;
    Rectangle1: TMenuItem;
    Ellipses1: TMenuItem;
    Dessin2: TMenuItem;
    procedure Rectangle1Click(Sender: TObject);
    procedure Ellipses1Click(Sender: TObject);
    procedure Dessin2Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
    dessin: (un_rectangle, une_ellipse);
  end;

var
  fille_graphique: Tfille_graphique;

implementation
  uses u_dialo6, u_filsa6;

{$R *.DFM}

procedure Tfille_graphique.Rectangle1Click(Sender: TObject);
begin
  dessin:= un_rectangle;
end;

procedure Tfille_graphique.Ellipses1Click(Sender: TObject);
begin
  dessin:= une_ellipse;
end;

procedure Tfille_graphique.Dessin2Click(Sender: TObject);
var indice: Integer;
    valeur: Integer;
    x_dessin: Integer;
begin
  x_dessin:= 0;
  for indice:= 0 to Form1.ComponentCount- 1 do
  begin
    if Form1.Components[indice] Is tfille_saisie
      then begin
          with Form1.components[indice] as tfille_saisie do
          begin
            valeur:= StrToInt(Edit1.text);
            with PaintBox1.Canvas do
            begin
              Brush.Color:= clRed;
              case dessin of
                un_rectangle : rectangle(x_dessin, 0, x_dessin+ 30, valeur);
                une_ellipse : ellipse(x_dessin, 0, x_dessin+ 30, valeur);
              end; (* case *)
            end;
            inc(x_dessin, 32);
          end; (* with saisie *)
        end; (* a une bote de saisie *)
  end; (* for indice *)
end;

end.
