unit U_ini4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
  uses IniFiles;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
  var mon_ini: tIniFile;
      x_grille: Integer;
      dir_base: String;
      debugging: Boolean;
begin
  mon_ini:= tIniFile.Create('DELPHI.INI');

  x_grille:= mon_ini.ReadInteger('FormDesign', 'GridSizeX', -1);
  Canvas.TextOut(200, 5, 'grille x: '+ IntToStr(x_grille));

  dir_base:= mon_ini.ReadString('Gallery', 'BaseDir', 'pas trouv');
  Canvas.TextOut(200, 25, 'dir gallerie: '+ dir_base);

  debugging:= mon_ini.ReadBool('Debugging', 'IntegratedDebugging', True);
  If debugging
    then Canvas.TextOut(200, 45, 'dbugging intgr')
    else Canvas.TextOut(200, 45, 'dbugging externe');

  mon_ini.ReadSectionValues('COMPLIB.DCL.Palette', ListBox1.Items);
  Canvas.TextOut(200, 75, 'Standard: '+ ListBox1.Items.Values['Standard']);

  mon_ini.Free;
end;

end.
