(* -- FontDialog *)

unit U_fontdi;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    FontDialog1: TFontDialog;
    FontDialog2: TFontDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FontDialog1Apply(Sender: TObject; Wnd: Word);
    procedure FormClick(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  If FontDialog1.Execute
    then Font:= FontDialog1.Font;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
{
  MessageBeep(0);
  Canvas.TextOut(100, 100, 'AaBbCc');
}
end;

procedure TForm1.FontDialog1Apply(Sender: TObject; Wnd: Word);
begin
  Font:= FontDialog1.Font;
  Canvas.TextOut(20, 50, 'AaBbCc');
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  Canvas.TextOut(120, 50, 'AaBbCc');
end;

end.
