unit U_memo3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Charge1: TMenuItem;
    Cherche1: TMenuItem;
    Remplace1: TMenuItem;
    FindDialog1: TFindDialog;
    procedure Charge1Click(Sender: TObject);
    procedure Cherche1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Charge1Click(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile('u_memo3.pas');
end;

procedure TForm1.Cherche1Click(Sender: TObject);
begin
  FindDialog1.FindText:= 'aha';
  FindDialog1.Execute;

  Canvas.TextOut(220, 10, 'Cherche >'+ FindDialog1.FindText+ '<');
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
const nombre_recherches: Integer= 0;
var indice, indice_trouve: Integer;
    indice_courant, indice_ligne: Integer;
begin
  Canvas.TextOut(220, 40, 'recherche numro '+ IntToStr(nombre_recherches)+ '>'+ FindDialog1.FindText+ '<');
  inc(nombre_recherches);

  indice:= Memo1.SelStart;
  Canvas.TextOut(220, 60, ' partir de indice '+ IntToStr(indice));

  (* -- cherche la ligne correspondant  cet indice *)
  indice_courant:= 0; indice_ligne:= 0;
  While (indice_courant< indice) do
  begin
    indice_courant:= indice_courant+ Length(Memo1.Lines[indice_ligne])+ 2;
    inc(indice_ligne);
  end;
  Canvas.TextOut(220, 80, ' partir de la ligne '+ IntToStr(indice_ligne));

  (* -- recherche pour toutes les lignes qui suivent *)
  indice_trouve:= 0;
  While (indice_trouve= 0) and (indice_ligne< Memo1.Lines.Count) do
  begin
    indice_trouve:= Pos(FindDialog1.FindText, Memo1.Lines[indice_ligne]);

    if indice_trouve= 0
      then inc(indice_ligne)
  end;

  if indice_trouve> 0
    then Canvas.TextOut(220, 100, 'Trouv  ligne '+ IntToStr(indice_ligne)+ ' '+ Memo1.Lines[indice_ligne]
        + ',  indice: '+ IntToStr(indice_trouve))
    else Canvas.TextOut(220, 100, 'Pas trouv');
end;

end.

procedure TForm1.FindDialog1Find(Sender: TObject);
var
  X, Stop, Direction: Integer;

  function DoCase(const S: string): string;
  begin
    if frMatchCase in FindDialog1.Options then
      Result := S else
      Result := UpperCase(S);
  end;

begin
  if FindDialog1.FindText = '' then
    MessageBeep(0)
  else
  begin
   { Start search at current position }
    X := Listbox1.ItemIndex;
    if frDown in FindDialog1.Options then
    begin
      Direction := 1;
      Stop := Listbox1.Items.Count;
    end
    else
    begin
      Direction := -1;
      Stop := -1;
      { If nothing is selected, start below last item and go up }
      if X = -1 then X := Listbox1.Items.Count;
    end;

    { move off current item first }
    Inc(X, Direction);
    while X <> Stop do
    begin
      if Pos(DoCase(FindDialog1.FindText), DoCase(ListBox1.Items[X])) > 0 then
        Break;
      Inc(X, Direction);
    end;
    if X <> Stop then
      Listbox1.ItemIndex := X
    else
      MessageDlg('Search string '''+FindDialog1.FindText+''' not found.',
        mtInformation, [mbOk], 0);
  end;
end;


