unit U_clavi2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormEnter(Sender: TObject);
    procedure FormExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-declarations }
    x_caret, y_caret: Integer;
    x_caret_max: Integer;
    nord_est_enfoncee: Boolean;
    double: String;
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormEnter(Sender: TObject);
begin
  CreateCaret(Handle, 0, 4, Canvas.TextHeight('a'));
  SetCaretPos(x_caret, y_caret);
  ShowCaret(Handle);
end;

procedure TForm1.FormExit(Sender: TObject);
begin
  HideCaret(Handle);
  DestroyCaret;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    vk_Home : begin
                if x_caret> x_caret_max
                  then x_caret_max:= x_caret;

                x_caret:= 0;
                SetCaretPos(x_caret, y_caret);
              end;
    vk_End : begin
               x_caret:= x_caret_max;
               SetCaretPos(x_caret, y_caret);
             end;
    vk_Up : begin
              nord_est_enfoncee:= True;
              double:= '';
            end;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  HideCaret(Handle);
  Canvas.TextOut(x_caret, y_caret, key);
  if nord_est_enfoncee
    then double:= double+ Key;
  ShowCaret(Handle);

  x_caret:= x_caret+ Font.Size;
  SetCaretPos(x_caret, y_caret);
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key= vk_Up
    then begin
        nord_est_enfoncee:= False;
        Canvas.TextOut(0, ClientRect.Bottom- Canvas.TextHeight('A'),
          '>'+ double+ '<  ');
      end;
end;

end.
