unit U_souri2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    FileListBox1: TFileListBox;
    Memo1: TMemo;
    procedure Memo1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FileListBox1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure Memo1DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Memo1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var resultat: String;
begin
  resultat:= 'Memo1DragOver(Sender= '
      + (Sender as tControl).Name
      + ', Source= '
      + (Source as tFileListBox).Name+ ')';
  Canvas.TextOut(Memo1.Left, Memo1.Top+ Memo1.Height, resultat);

  Accept:= True;
end;

procedure TForm1.Memo1DragDrop(Sender, Source: TObject; X, Y: Integer);
var resultat: String;
begin
  resultat:= 'Memo1DragDrop(Sender= '
    + (Sender as tMemo).Name
    + ', Source= '+
    + (Source as tFileListBox).Name+ ')';

  Canvas.TextOut(Memo1.Left, Memo1.Top+ Memo1.Height+ 20, resultat);

  Memo1.Lines.LoadFromFile(FileListBox1.Items[FileListBox1.ItemIndex]);
end;

procedure TForm1.FileListBox1EndDrag(Sender, Target: TObject; X,
  Y: Integer);
var resultat: String;
begin
  resultat:= 'FileListBox1EndDrag(Sender= '
      + (Sender as tFileListBox).Name
      + ', Target= ';
  IF Target= Nil
    then resultat:= resultat+ ' NIL (refus) )'
    else resultat:= resultat+ (Target as tComponent).Name+ ' )';

  Canvas.TextOut(Memo1.Left, Memo1.Top+ Memo1.Height+ 40, resultat);
end;

end.
