unit U_grid1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Longint;
      const Value: String);
    procedure StringGrid1GetEditText(Sender: TObject; ACol, ARow: Longint;
      var Value: OpenString);
    procedure Button1Click(Sender: TObject);
  private
    { Private-declarations }
    y_edite: Integer;
    chaine: String;
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var colonne: Integer;
begin
  StringGrid1.Cells[0, 1]:= 'Ventes';
  StringGrid1.Cells[0, 2]:= 'Achats';
  StringGrid1.Cells[0, 3]:= 'Rsultat';
  For colonne:= 1 to 12 do
  begin
    StringGrid1.Cells[colonne, 0]:= IntToStr(colonne);

    StringGrid1.Cells[colonne, 1]:= IntToStr(100+ Random(30));
    StringGrid1.Cells[colonne, 2]:= IntToStr(80+ Random(20));
    StringGrid1.Cells[colonne, 3]:=
        IntToStr( StrToInt(StringGrid1.Cells[colonne, 1])- StrToInt(StringGrid1.Cells[colonne, 2]) );
  end;

end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
{
  StringGrid1.Canvas.DrawFocusRect(Rect);
}
end;

procedure TForm1.StringGrid1GetEditText(Sender: TObject; ACol,
  ARow: Longint; var Value: OpenString);
begin
  if (Arow= 1) and (aCol= 1)
    then begin
{
         MessageBeep(0);
        Canvas.TextOut(0, y_edite, 'Get '+ Value+ ' '+ IntToStr(y_edite));
        inc(y_edite, 20);
}
      end;

  if Arow> 1
    then chaine:= StringGrid1.Cells[Acol, Arow];
end;

procedure TForm1.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Longint; const Value: String);
var chaine_vente: String;
    achat, vente: Integer;
begin
  if (Arow= 1) and (aCol= 1)
    then begin
{
         MessageBeep(0);
        Canvas.TextOut(0, y_edite, 'Set '+ Value+ ' '+ IntToStr(y_edite));
        inc(y_edite, 20);
}
      end;

  if (Arow= 1) and (aCol>= 1)
    then begin
        chaine_vente:= StringGrid1.Cells[Acol, 1];
        if chaine_vente<> ''
          then begin
              vente:= StrToInt(chaine_vente);
              achat:= StrToInt(StringGrid1.Cells[Acol, 2]);
              StringGrid1.Cells[Acol, 3]:= IntToStr(vente- achat);
            end;
      end;

  if Arow> 1
    then StringGrid1.Cells[Acol, Arow]:= chaine;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  StringGrid1.TopRow:= StringGrid1.RowCount- 1;
end;

end.
