unit U_tool3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton5: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton7Click(Sender: TObject);
  private
    { Private-declarations }
    couleur: tColorRef;
    x_precedent, y_precedent: Integer;
    dessin_en_cours: Boolean;
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  couleur:= clGreen;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  couleur:= clRed;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  dessin_en_cours:= true;
  x_precedent:= x; y_precedent:= y;
  Canvas.MoveTo(x_precedent, y_precedent);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  dessin_en_cours:= False;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If dessin_en_cours
    then begin
        Canvas.Pen.Color:= couleur;
        Canvas.LineTo(x, y);
        x_precedent:= x; y_precedent:= y;
      end;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  If SpeedButton6.Down
    then MessageBeep(0);
end;

end.
