unit U_edit7;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure affiche_selection;
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1Change(Sender: TObject);
  private
    { Private-declarations }
{
    minuscules: String;
}
    resultat: String;
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text:= '';
end;

procedure tForm1.affiche_selection;
  begin
    Canvas.TextOut(150, 50, 'SelStart: '+ IntToStr(Edit1.SelStart)+ '  ');
    Canvas.TextOut(150, 70, 'SelLength: '+ IntToStr(Edit1.SelLength)+ '  ');
  end;

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  affiche_selection;

end;

procedure TForm1.Edit1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  affiche_selection;
end;

procedure TForm1.Edit1Change(Sender: TObject);
var indice {, taille } : Integer;
    erreur: Boolean;
    indice_changement: Integer;
begin
  (* -- mmorise la position en cas d'erreur *)
  Indice_changement:= Edit1.SelStart;

  Canvas.TextOut(10, 50, 'rsu: '+ resultat+ '<     ');
  Canvas.TextOut(10, 70, 'Text: '+ Edit1.Text+ '<     ');

  indice:= 1; erreur:= False;

  while (indice<= 10) and (indice<= Length(Edit1.Text)) and not erreur do
  begin
    case indice of
      1..5 : if not (Edit1.Text[indice] in ['a'..'z'])
               then erreur:= true;
      6..10 : if not (Edit1.Text[indice] in ['0'..'9'])
                then erreur:= true;
    end;
    indice:= indice+ 1;
  end;

  if erreur
    then begin
        MessageBeep(0);
        (* -- restaure le texte prcdent *)
        Edit1.Text:= resultat;
        (* -- positionne le caret *)
        Edit1.SelStart:= indice_changement- 1;
       end
     else resultat:= Edit1.Text;

  affiche_selection;
  Canvas.TextOut(300, 50, 'rsu: '+ resultat+ '<     ');
  Canvas.TextOut(300, 70, 'Text: '+ Edit1.Text+ '<     ');
end;

end.
