unit U_client;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    Edite1: TMenuItem;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-declarations }
    delta: Integer;
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure affiche;
  var l_titre: String;
  begin
    with Form1 do
    begin
      if Panel1.Visible
        then l_titre:= ' Panel'
        else l_titre:= '';
      if HorzScrollBar.Visible
        then l_titre:= l_titre+ ' Dfile';
      if Menu<> Nil
        then l_titre:= l_titre+ ' Menu';

      Canvas.TextOut(0, Button1.Top+ Button1.Height+ 10+ delta,
        'Fentre: '+ IntToStr(Height)+ ' '
        + ', Client: '+ IntToStr(ClientRect.Bottom)
        + '  ('+ l_titre+ ')');

      inc(delta, 20);
    end;
  end; (* affiche *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  Panel1.Visible:= not Panel1.Visible;
  affiche;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  HorzScrollBar.Visible:= Not HorzScrollBar.Visible;
  affiche;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  affiche;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  If Menu= Nil
    then Menu:= MainMenu1
    else Menu:= Nil;
  affiche;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Menu:= nil;
end;

end.


