unit U_dialo6;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Cre1: TMenuItem;
    Ajoute1: TMenuItem;
    Fentres1: TMenuItem;
    Cascade1: TMenuItem;
    Tuiles1: TMenuItem;
    Icnes1: TMenuItem;
    procedure Ajoute1Click(Sender: TObject);
    procedure Ferme1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Tuiles1Click(Sender: TObject);
    procedure Icnes1Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation
  uses u_filsa6, u_filgr6 { , ExtCtrls }  ;

{$R *.DFM}

procedure TForm1.Ajoute1Click(Sender: TObject);
var forme_saisie: tfille_saisie;
begin
  forme_saisie:= tfille_saisie.Create(Self);
  forme_saisie.visible:= True;
  forme_saisie.Edit1.Text:= '0';
(* si Visibl= True, il suffit de : 
  tfille_saisie.Create(Self);
*)
end;

procedure TForm1.Ferme1Click(Sender: TObject);
var indice: Integer;
    valeur: Integer;
    x_dessin: Integer;
begin
  x_dessin:= 0;
  for indice:= 0 to ComponentCount- 1 do
  begin
    if Components[indice] Is tfille_saisie
      then begin
          with components[indice] as tfille_saisie do
          begin
            valeur:= StrToInt(Edit1.text);
            with fille_graphique, PaintBox1.Canvas do
            begin
              Brush.Color:= clRed;
              case dessin of
                un_rectangle : rectangle(x_dessin, 0, x_dessin+ 30, valeur);
                une_ellipse : ellipse(x_dessin, 0, x_dessin+ 30, valeur);
              end; (* case *)
            end;
            inc(x_dessin, 32);
          end; (* with saisie *)
        end; (* a une bote de saisie *)
  end; (* for indice *)
end;

procedure TForm1.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TForm1.Tuiles1Click(Sender: TObject);
begin
  TileMode:= tbVertical;
  Tile;
end;

procedure TForm1.Icnes1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

end.


