unit U_millie;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask;

type
  TForm1 = class(TForm)
    MaskEdit1: TMaskEdit;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function f_ajoute_points(p_chaine: String): String;
  var l_millier, l_taille: Integer;
  begin
    l_taille:= Length(p_chaine);
    for l_millier:= ( (l_taille- 1) div 3) downto 1 do
    begin
      Insert('.', p_chaine, l_taille- (l_millier* 3)+ 1);
      inc(l_taille);
    end;

    f_ajoute_points:= p_chaine;
  end; (* f_ajoute_points *)

function f_supprime_espaces_tete(p_chaine: String): String;
  begin
    while (p_chaine[1]= ' ') and (Length(p_chaine)> 0) do
      delete(p_chaine, 1, 1);
    f_supprime_espaces_tete:= p_chaine;
  end; (* f_supprime_espaces_tete *)

function f_supprime_zeros_fin(p_chaine: String): String;
  var l_indice: Integer;
  begin
    l_indice:= Length(p_chaine);
    while p_chaine[l_indice]= '0' do
      dec(l_indice);
    p_chaine[0]:= chr(l_indice);
    f_supprime_zeros_fin:= p_chaine;
  end; (* f_supprime_zeros_fin *)

procedure TForm1.Button1Click(Sender: TObject);
var l_chaine: String;
begin
  Canvas.TextOut(Button1.Left+ Button1.Width+ 10, Button1.Top,
      f_ajoute_points(MaskEdit1.Text));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Canvas.TextOut(Button2.Left+ Button1.Width+ 10, Button2.Top,
      '>'+ f_supprime_espaces_tete(f_supprime_zeros_fin(Edit1.Text))+ '<');
end;

end.
