unit U_replac;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Cherche1: TMenuItem;
    Remplace1: TMenuItem;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    procedure FormCreate(Sender: TObject);
    procedure Cherche1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure Remplace1Click(Sender: TObject);
  private
    { Private-declarations }
  public
    { Public-declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile('u_replac.pas');
end;

procedure TForm1.Cherche1Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
var l_pt_cherche: pChar;

    l_pt_texte: pChar;
    l_taille_texte: Word;

    l_pt_courant: pChar;
begin
  GetMem(l_pt_cherche, 1+ Length(FindDialog1.FindText));
  StrPCopy(l_pt_cherche, FindDialog1.FindText);

  (* -- copie pour pouvoir utiliser les primitives pChar *)
  l_taille_texte:= Memo1.GetTextLen+ 1;
  GetMem(l_pt_texte, l_taille_texte);
  Memo1.GetTextBuf(l_pt_texte, l_taille_texte);

  (* -- commence  la position du caret *)
  l_pt_courant:= l_pt_texte+ Memo1.SelStart+ Memo1.SelLength;

  (* -- la recherche *)
  l_pt_courant:= StrPos(l_pt_courant, l_pt_cherche);

  if l_pt_courant<> nil
    then begin
        (* -- slectionne le texte trouv et place le caret  la fin *)
        Memo1.SelStart:= l_pt_courant- l_pt_texte;
        Memo1.SelLength:= Length(FindDialog1.FindText);
      end;

  FreeMem(l_pt_cherche, 1+ Length(FindDialog1.FindText));
  FreeMem(l_pt_texte, l_taille_texte);
end;


procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
var l_fini: Boolean;
begin
  with ReplaceDialog1 do
  begin
    l_fini:= False;
    MessageBeep(0);

    while not l_fini do
    begin
      (* -- si le texte cherch n'est pas le texte slectionn *)
      (* -- recherche et slectionne FindText *)
      if Memo1.SelText<> FindText
        then begin
            FindDialog1.FindText:= FindText;
            FindDialog1Find(Sender);
          end;
      if Memo1.SelLength= 0
        then l_fini:= true
        else begin
            (* -- remplace la slection *)
            Memo1.SelText:= ReplaceText;
            If not (frReplaceAll in Options)
              then l_fini:= true;
          end;
      l_fini:= true;
    end; (* while not l_fini *)
  end; (* with *)
end;

procedure TForm1.Remplace1Click(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

end.
